% GABminINIT   Gabor initialization file
%
% initalize variables for gabor analysis
% -> original (g), dual (gd) and tight window (gt)
% -> corresponding analysis operator (G, GD, GT), also for adjoint lattice
% (GA)
% -> frame operator for original window and lattice (S)
% Show windows and their spectra
%
% derived from gabinit.m ny HGFei
% modified by XXL to work with the GABMIN tools
% but check for other files

% XXL: contact a8927259@unet.univie.ac.at
% last modification 09.12.2004

%clc;  
disp(' Attention. This script tries to use existing variables. ');
disp(' If you want to make sure, that you use the desired variables, ');
disp(' assign g,a,b and n. At the moment ')
whos g;

if exist('a') == 1; 
    a
end;
if exist('b') == 1; 
    b
end;
if exist('n') == 1; 
    n
else 
    if exist('a') ~= 1 & exist('b') ~= 1
        disp ('No variable is  already set. So');
    end
    n = 144
%    disp('n is set to 144');
end;    
if exist('g') == 1;
    [N M] = size(g);
    if N > 1; 
        g=g.';
        [N M] = size(g);
    end;
    if N ==  1 & M > 1;
       n = M;
       disp(sprintf('g exists so n is set to %g',M));
   else     
        disp('Gauss function as window g created.');
        g = gaussnk(n);
    end;
else
    disp('Gauss function as window g created.');
    g = gaussnk(n);
end;

alph = alldiv(n); alph = alph(:)';  
mx1 = max(find(alph <= sqrt(n))); 
divs = alph(1:mx1),  
if exist('a') ~= 1 | a < 0 | a > n | mod(n,a) ~= 0;
    a = alph(mx1)        
     %disp(sprintf('a is set to %g',a));
end; 
if exist('b') ~= 1 | b < 0 | b > n |  mod(n,b)~= 0; % eval('b',0) ~= 0 | a*b > n |
    if mx1 == 1;
        b = round(n/a)
        if b == 0; 
            b = 1
        end;
    else  
        b = alph(mx1-1)
    end;
    %disp(sprintf('b is set to %g',b));
end;
if a*b > n  
    disp('The redundancy is smaller than one, so this cant be a frame');
end;

red = n/(a*b)
xpo = lattp(n,a,b);
xpa = lattp(n,n/b,n/a);  
gtt = '?';

disp('calculating dual atom'); 
% pause(1);  
if rem(red,1) == 0 & exist('zd') == 2;
    gd = zd(g,a,b);
    disp('using Zak transform with integer oversampling');  
elseif red == 1;
    gd = zakdfei(g,a,b);
    disp('using Zak transform in the critical case');  
else 
    gd = gabddd(g,a,b);  
end;
disp('dual atom done'); 
% pause(0.2);
if rem(red,1) == 0 & exist('zt') == 2;
   disp('calculating tight atom, using Zak transform');  
   gt = zt(g,a,b); 
elseif exist('gabtgf') == 2;
   disp('dual atom done, doing tight atom now');  
   gt = gabtgf(g,a,b);  
else 
    disp('no tight atom is calculated, no tool in Gabmin');
    gtt = 'no';
    % gt is a built-in function, so use actual assignment and not clear
end;  
% f3sp(g,gt,gd);  
disp('now establishing matrices');  
pause(1); 
if red*n < 540 
    G = gabbasp(g,a,b);
    GD = gabbasp(gd,a,b); 
    if gtt ~= 'no';
        GT = gabbasp(gt,a,b);
    end;
    S = G'*G; 
    GA =  gabbasp(g,n/b,n/a);  
else
    sprintf('red*n is too large (%d) to automatically establish matrices',red*n); 
end; 
disp('call "whos" for more details');  
% disp('f3sp(g,gt,gd); shows Gabor atoms, tight + dual');  
if gtt ~= 'no' & exist('gt') == 1 & exist('f3sp') == 2;
    f3sp(g,gt,gd);
else
    f2sp(g,gd);
end;
