% test HSGRamMatrXXL 
%
% Ref.: P. Balazs, "Regular And Irregular Gabor Multipliers With
%       Application To Psychoacoustic Masking"
%
% See testproj, HSGramMatrXXL

n = 144;

g = randc(1,n); % Synthesis Atom
gamma = randc(1,n); % Analysis Atom

% g = gaussnk(n);
% gamma = hamming(n/2).';
% gamma= [gamma(1:n/4) zeros(1,n/2) gamma((n/4+1):(n/2))];

% for regular case :
% xpo = zeros(n,n);
% a = 9;
% b = 9;
% xpo(1:b:n,1:a:n) = 1;

xpo = rand(n) > 1-2/n; % red = 2
G = gabbaspirr(g,xpo);
Ga = gabbaspirr(gamma,xpo);
Gram1 = HSGramMatrXXL(xpo,g,gamma);

[xpx xpy] = find(xpo > 0);
K = length(xpx);
Gram2 = zeros(K);
Vfull = stft(g,g,1,1);
Wfull = stft(gamma,gamma,1,1);
for ii = 1:K;
    for jj = 1:K;
    Gram2(ii,jj) = ...
        Vfull(mod(xpx(jj)-xpx(ii),n)+1,mod(xpy(jj)-xpy(ii),n)+1).*...
        conj(Wfull(mod(xpx(jj)-xpx(ii),n)+1,mod(xpy(jj)-xpy(ii),n)+1));   
    end;
end;

%PHS = zeros(K,n*n);
%Pnull = gamma'*g;
%for ii = 1:K;
%    Ptemp = tfconj(Pnull,xpy(ii)-1,xpx(ii)-1);   
%    PHS(ii,:) = Ptemp(:);
%end;
%Gram3 = PHS*PHS'; 
% Gram3 = abs(PHS*PHS'); % why abs ????
%
% ATTENTION: Tfconj (Gabmin) imeplements modrot, not rotmod !!!!!!!!!!!!
%

Gram4 = (G*G').*conj(Ga*Ga'); % conj. !!

PHS2 = zeros(K,n*n);
for ii = 1:K;
    gal = rotmod(gamma,xpy(ii)-1,xpx(ii)-1);
    gl = rotmod(g,xpy(ii)-1,xpx(ii)-1); 
%   gal = modrot(gamma,xpx(ii)-1,xpy(ii)-1); %for comparison with tfconj
%   gl = modrot(g,xpx(ii)-1,xpy(ii)-1); 
    Ptemp = gal'* gl;
    PHS2(ii,:) = Ptemp(:);
end;
% disp('*** PHS - PHS2:');compnorm(PHS,PHS2);
Gram5 = PHS2*PHS2'; 

disp('                                         ');
disp('*** Gram1-Gram2');compnorm(Gram1,Gram2);
%disp('*** Gram1-Gram3');compnorm(Gram1,Gram3);
disp('*** Gram1-Gram4');compnorm(Gram1,Gram4);
disp('*** Gram1-Gram5');compnorm(Gram1,Gram5);
%disp('*** Gram2-Gram3');compnorm(Gram2,Gram3);
disp('*** Gram2-Gram4');compnorm(Gram2,Gram4);
disp('*** Gram2-Gram5');compnorm(Gram2,Gram5);
%disp('*** Gram3-Gram4');compnorm(Gram3,Gram4);
%disp('*** Gram3-Gram5');compnorm(Gram3,Gram5);
disp('*** Gram4-Gram5');compnorm(Gram4,Gram5);
% rank(G'*G)
%rank(Ga'*Ga)

% Tests:
% n = 144;
% *** Gram1-Gram2
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 0 .
% *** Gram1-Gram4
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 4.2874e-015 .
% *** Gram1-Gram5
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 5.11798e-015 .
% *** Gram2-Gram4
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 4.2874e-015 .
% *** Gram2-Gram5
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 5.11798e-015 .
% *** Gram4-Gram5
% Norm of first input x: 9387.5 , norm of second input y: 9387.5 , quotient =  1 .
% norm of the difference of the normalized versions  = 2.85202e-015 .